/******************************************************************************
 *  pre.c -- Test program for the S5920 prototype board                       *
 *                                                                            *
 *  (c) 2004 Greg Burley                                                      *
 *                                                                            *
 *                                                                            *
 *  This program tests the S5920 prototype board using ioctl() calls.         *
 *  It uses the real driver ("/dev/amcc") and the PCI interface.              *
 *                                                                            *
 ******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/io.h>                 /* for inl() and outl() */
#include <asm/types.h>
#include <sys/time.h>
#include "amcc.h"

static int  amcc_fd = 0L;           /* device */

/*========== Main program ====================================================*/
int
main ()
{
    int r, w;
    u_int icsr, rcr, ptcr, mbef;

    amcc_fd = open ("/dev/amcc0", O_RDWR);
    if (amcc_fd == -1){
        printf ("Error opening device /dev/amcc0 \n");
        exit(0);
    }
    else {
        printf ("Device /dev/amcc0 opened\n");
    }

    r = ioctl(amcc_fd, AMCC_RESET_ADDON);

    /* Scan the operation registers */
    r = ioctl(amcc_fd, AMCC_GET_ICSR , &icsr);
    r = ioctl(amcc_fd, AMCC_GET_RCR , &rcr);
    r = ioctl(amcc_fd, AMCC_GET_PTCR , &ptcr);
    r = ioctl(amcc_fd, AMCC_GET_MBEF , &mbef);
    printf("ICSR %08x  MBEF %08x  RCR %08x  PTCR %08x\n",
            icsr, mbef, rcr, ptcr);

    if (amcc_fd){
        close (amcc_fd);
        printf("Device /dev/amcc0 closed\n");
    }

    return EXIT_SUCCESS;    /* to make gcc happy */
}

